<template>
  <main>
    <header class="q-pa-md row justify-between items-center">
      <span class="text-bold">{{ t('insureanceCalculator') }}</span>
      <LanguageSwitcher class="col-4" />
    </header>
    <div class="flex justify-center">
      <q-stepper
        ref="stepper"
        v-model="step"
        header-nav
        swipeable
        keep-alive
        :contracted="isSmallScreen"
        bordered
        flat
        color="primary"
        animated
      >
        <q-step
          :name="1"
          :title="t('typeOfInsurance')"
          icon="info"
          :done="step > 1"
          :header-nav="step > 1"
        >
          <first-step
            v-model:countOfPeople="countOfPeople"
            v-model:selectedPackage="selectedPackage"
            v-model:selectedInsuranceType="selectedInsuranceType"
          />
          <small>("*") Povinné polia</small>
          <q-stepper-navigation>
            <q-btn
              :disabled="!selectedPackage || !selectedInsuranceType"
              @click="
                () => {
                  done2 = true;
                  step = 2;
                }
              "
              color="primary"
              :label="t('buttons.continue')"
            />
            <q-btn
              flat
              @click="step = 1"
              color="primary"
              :label="t('buttons.back')"
              class="q-ml-sm"
            />
          </q-stepper-navigation>
        </q-step>

        <q-step
          :name="2"
          :title="t('insurancePeriod')"
          icon="settings"
          :done="step > 2"
          :header-nav="step > 2"
        >
          <second-step
            v-model:selectedStartDate="selectedStartDate"
            v-model:selectedEndDate="selectedEndDate"
            v-model:isCorrectStartDate="isCorrectStartDate"
            v-model:isCorrectEndDate="isCorrectEndDate"
            v-model:selectedInsuranceType="selectedInsuranceType"
            @update:daysCount="handleDaysCountUpdate"
          />
          <q-stepper-navigation>
            <q-btn
              :disabled="isButtonDisabled"
              @click="
                () => {
                  done2 = true;
                  step = 3;
                }
              "
              color="primary"
              :label="t('buttons.continue')"
            />
            <q-btn
              flat
              @click="step = 1"
              color="primary"
              :label="t('buttons.back')"
              class="q-ml-sm"
            />
          </q-stepper-navigation>
        </q-step>
        <q-step
          :name="3"
          :title="t('additionalIssuarance')"
          icon="settings"
          :done="step >= 3"
          :header-nav="step > 3"
        >
          <third-step
            :isSummaryVisible="isSummaryVisible"
            v-model:selectedAdditionalInsurance="selectedAdditionalInsurance"
            v-model:summary="summary"
            v-model:additionalInsurance="additionalInsurance"
            :selectedInsuranceType="selectedInsuranceType"
          />
          <q-stepper-navigation>
            <q-btn
              :disabled="additionalInsurance && !selectedAdditionalInsurance"
              @click="showTotal"
              color="secondary"
              :label="
                !isSummaryVisible
                  ? t('buttons.showResult')
                  : t('buttons.hideResult')
              "
            />
            <q-btn
              flat
              @click="step = 2"
              color="primary"
              :label="t('buttons.back')"
              class="q-ml-sm"
            />
          </q-stepper-navigation>
        </q-step>
      </q-stepper>
    </div>
  </main>
</template>

<script setup lang="ts">
import { validateDate } from '../utils/validateDates';
import { ref, watch, computed,defineAsyncComponent } from 'vue';
import { useI18n } from 'vue-i18n';
import { date } from 'quasar';
import { Screen } from 'quasar';
const LanguageSwitcher = defineAsyncComponent(() =>
  import('../components/language-switcher.vue')
);
const FirstStep = defineAsyncComponent(() =>
  import('../components/steps/first-step.vue')
);
const SecondStep = defineAsyncComponent(() =>
  import('../components/steps/second-step.vue')
);
const ThirdStep = defineAsyncComponent(() =>
  import('../components/steps/third-step.vue')
);
import { config } from '../utils/insurence-contansts';
const { t } = useI18n();
const isSmallScreen = computed(() => Screen.width <= 600);

// Default state of inputs
const selectedPackage = ref(null);
const selectedInsuranceType = ref(null);
const isCorrectStartDate = ref(true);
const isCorrectEndDate = ref(true);
const countOfPeople = ref(1);
const days = ref(1);
const isSummaryVisible = ref(false);
const selectedStartDate = ref(null);
const selectedEndDate = ref(null);

const handleDaysCountUpdate = (newDaysCount: number) => {
  days.value = newDaysCount;
};
const selectedAdditionalInsurance = ref(null);
const additionalInsurance = ref(false);

const step = ref(1);
const done1 = ref(false);
const done2 = ref(false);
const done3 = ref(false);

const summary = computed(() => {
  // Initial total based on package and count of people.
  let total = selectedPackage.value * countOfPeople.value;
  // If the insurance is short-term, multiply with daysCount.
  if (
    selectedInsuranceType.value === t('possibleInsuranceTypeOptions.shortTime')
  ) {
    total *= days.value;
  }
  // If additional insurance is selected, adjust the total.
  if (additionalInsurance.value && selectedAdditionalInsurance.value) {
    total *= selectedAdditionalInsurance.value;
  }
  // Check for NaN and return 0 if true.
  if (isNaN(total)) {
    return 0;
  }
  // Round the total to 2 decimal places, rounding up.
  return Math.ceil(total * 100) / 100;
});

const showTotal = () => {
  isSummaryVisible.value = !isSummaryVisible.value;
};
const isButtonDisabled = computed(() => {
  if (
    selectedInsuranceType.value === t('possibleInsuranceTypeOptions.longTime')
  ) {
    return !isCorrectStartDate.value || !selectedStartDate.value;
  }
  return (
    !isCorrectStartDate.value ||
    !isCorrectEndDate.value ||
    !selectedStartDate.value ||
    !selectedEndDate.value
  );
});
</script>
